#include <stdio.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "Labyrinth.h"

#define MAP_WDH			(WDH-1)/2		// n}̉
#define MAP_HGT			(HGT-1)/2		// n}̍
#define P_NUM			15				// ʘHbV̐
#define P_SIZE			0.6f			// ʘHbV̈ӂ̒
#define L_D				0.05f			// _ƒ_̋
#define TAG_LEN			256				// ECTiBINjt@C̃^O̍ő啶
#define PI				(float)3.1415926535897932
#define SAFE_DELETE(p) 	if (p){delete[] p;p=NULL;}
#define WIDTHBYTES(pbi)	((pbi->bmiHeader.biWidth * pbi->bmiHeader.biBitCount + 31) / 32 * 4)

typedef struct{
	GLfloat x;
	GLfloat y;
}GLVECTOR2,*LPGLVECTOR2;

typedef struct{
	GLfloat x;
	GLfloat y;
	GLfloat z;
}GLVECTOR3,*LPGLVECTOR3;

typedef struct{
	GLVECTOR3	v[P_NUM][32];		// _̍W
	GLVECTOR3	n[P_NUM][32];		// _̖@xNg
	GLVECTOR2	t[2][4];			// _̃eNX`W
	int 		f[P_NUM][10][4];	// eʂ̒_ԍ
	int 		face_ct[P_NUM];		// eʐ
}PASS,*LPPASS;

typedef struct{
	int		wdh,hgt;			// 摜̉A
	BYTE	*data;				// sNZ f[^
}TEX,*LPTEX;

HDC			g_hDC;
HGLRC		g_hRC;
PASS		g_p2;					// ʘH̃bV f[^
TEX			g_pTex;					// eNX` f[^
float		g_look_x = 0.0f;		// _ X W
float		g_look_y = 0.3f;		// _ Y W
float		g_look_z = 0.0f;		// _ Z W
float		g_pos_x;				// _XW
float		g_pos_z;				// _ZW
float		g_roll = 180;			// _̉]px (x)
int			g_flagDir;				// ݂̉]i:0, :1, :2, k:3j
int 		g_map1[MAP_HGT][MAP_WDH];// n}f[^i[
bool 		g_map2[MAP_HGT][MAP_WDH];// isoHi[
bool 		g_map3[MAP_HGT][MAP_WDH];// isoHi[ipj
bool		g_map4[MAP_HGT][MAP_WDH];// `tOi`悷:1, `悵Ȃ:0j
bool		g_wall[P_NUM][4] = {{0,0,0,1},{0,0,1,0},{0,1,0,0},{1,0,0,0},
								{1,0,0,1},{0,0,1,1},{0,1,1,0},{1,1,0,0},
								{1,0,1,1},{0,1,1,1},{1,1,1,0},{1,1,0,1},
								{1,0,1,0},{0,1,0,1},{0,0,0,0} };	// eʘH̕ǂ̃tO
int			g_Tuv[P_NUM] = { 1, 1, 1, 1, 2, 2, 2, 2,
							-1,-1,-1,-1,-1,-1, 0 };	// 0.1{̏ktO

bool	bSetupPixelFormat(HDC hdc);
bool	InitGL(HWND hWnd);
void	Set_Fog();
void	Set_Texture();
void	Set_EyePos();
void	Draw_Main();
void	Draw_Passage();
void	Visible_Passage();
bool	Visible_Passage_Sub (int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub1(int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub2(int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub3(int nx, int nz, int flagDir, int range);
bool	Visible_Passage_Sub4(int nx, int nz, int flagDir, int range);
void	Go();
void	Create_Map();
bool	Load_EctFile_Bin(void *pMem, int size);
bool	Load_EctFile(void *pMem);
bool	LoadBMP();
void	Term(HWND hWnd);

bool bSetupPixelFormat(HDC hdc)
{
	PIXELFORMATDESCRIPTOR pfd;
	int pixelformat;
	
	ZeroMemory(&pfd, sizeof(PIXELFORMATDESCRIPTOR));
	pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR);
	pfd.nVersion = 1;
	pfd.dwFlags = PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
	pfd.dwLayerMask = PFD_MAIN_PLANE;
	pfd.iPixelType = PFD_TYPE_RGBA;
	pfd.cColorBits = 24;
	pfd.cDepthBits = 16;
	
	if( (pixelformat = ChoosePixelFormat(hdc, &pfd)) == 0 )
		return false;
	
	if(SetPixelFormat(hdc, pixelformat, &pfd) == FALSE)
		return false;
	
    return true;
}// bSetupPixelFormat

// OpenGL ̏
bool InitGL(HWND hWnd)
{
	g_hDC = GetDC(hWnd); 
	if(!bSetupPixelFormat(g_hDC))
		return false;
	
	g_hRC = wglCreateContext(g_hDC);
	wglMakeCurrent(g_hDC, g_hRC);
	
	RECT rect;
	int  x,y,wdh,hgt,size;
	char s[WININI_BUF_SIZE];
	
	GetProfileString(WININI_SECTION, WININI_KEY, "1", s, WININI_BUF_SIZE);
	size = atoi(s);
	GetClientRect(hWnd, &rect);
	if(size == 0)
		size = 1;
	wdh = rect.right / size;
	hgt = rect.bottom / size;
	x = (rect.right - wdh) / 2;
	y = (rect.bottom - hgt) / 2;
	glViewport(x, y, wdh, hgt);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0, (double)rect.right/rect.bottom, 0.01, P_SIZE * 5);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);	// wiF
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_FOG);
	
	// n}f[^̓ǂݍ
	Create_Map();
	
	// eNX`̓ǂݍ
	LoadBMP();
	
	// eNX`W
	int i;
	for(i=0;i<2;i++){
		g_p2.t[i][0].x = 0;
		g_p2.t[i][0].y = 0;
		g_p2.t[i][1].x = 1;
		g_p2.t[i][1].y = 0;
		g_p2.t[i][2].x = 1;
		g_p2.t[i][2].y = 1;
		g_p2.t[i][3].x = 0;
		g_p2.t[i][3].y = 1;
	}
	g_p2.t[1][1].x = 0.1f;
	g_p2.t[1][2].x = 0.1f;
	
	// \[Xf[^ǂݍ
	HRSRC   hFound = FindResource(NULL,MAKEINTRESOURCE(IDR_TEXT1),"text");
	HGLOBAL hRes   = LoadResource(NULL,hFound);
	LPVOID	pMem   = LockResource(hRes);
	if(pMem == NULL){
		return false;
	}
	int size_res = SizeofResource(NULL, hFound);
	// ʘHbV̓ǂݍ
	if(!Load_EctFile_Bin(pMem, size_res)){
		if(!Load_EctFile(pMem)){
			return false;
		}
	}
	
	// _̏ʒu
	g_pos_x = 0.3f;
	g_pos_z = MAP_HGT * P_SIZE - 0.3f;
	
	Set_Fog();
	
	Set_Texture();
	return true;
}// InitGL

// tHO̐ݒ
void Set_Fog()
{
	GLfloat fogColor[4] = { 0.0f, 0.0f, 0.0f, 1.0f };
    
	glFogi(GL_FOG_MODE, GL_EXP2);
	glHint(GL_FOG_HINT, GL_NICEST);
	glFogfv(GL_FOG_COLOR, fogColor);
	glFogf(GL_FOG_START, 0.0f);
	glFogf(GL_FOG_END, 1.0f);
}// 

// eNX`̐ݒ
void Set_Texture()
{
	if (g_pTex.data != NULL){
		glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, g_pTex.wdh, g_pTex.hgt, GL_RGB, GL_UNSIGNED_BYTE, g_pTex.data);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
//		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);	// GL_MODULATE, GL_BLEND, GL_DECAL
	}
}// Set_Texture

// _̈ʒuƒ_̈ʒu
void Set_EyePos()
{
	g_look_x = -(float)sin(g_roll/180*PI) * L_D + g_pos_x;
	g_look_z = -(float)cos(g_roll/180*PI) * L_D + g_pos_z;
	GLdouble vLookatPt[3] = {g_pos_x, g_look_y, g_pos_z};
	GLdouble vUpVec[3]    = {0, 1, 0};
	glLoadIdentity();
	gluLookAt(g_look_x, g_look_y, g_look_z,
			vLookatPt[0], vLookatPt[1], vLookatPt[2],
			vUpVec[0], vUpVec[1], vUpVec[2]);
}// Set_EyePos

// `
void Draw_Main()
{
	Go();				// ړƉ]
	
	Set_EyePos();		// _̈ʒuƒ_̈ʒu
	
	Draw_Passage();		// ʘH̕`
}// Draw_Main

// ʘH̕`
void Draw_Passage()
{
	int			i,j,k,m,n;
	GLVECTOR3	vtx,nml;
	
	Visible_Passage();	// ʘH̉
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	for(n=0;n<MAP_HGT;n++){
		for(m=0;m<MAP_WDH;m++){
			if(!g_map4[n][m]){
				continue;
			}
			k = g_map1[n][m] - 1;
			for(i=0;i<g_p2.face_ct[k];i++){
				glBegin(GL_TRIANGLE_FAN);
				for(j=0;j<4;j++){
					if(g_Tuv[k] != -1 && i >= g_Tuv[k] && i < g_p2.face_ct[k] - 2){
						glTexCoord2f(g_p2.t[1][j].x, g_p2.t[1][j].y);	// XW 0.1{
					}
					else{
						glTexCoord2f(g_p2.t[0][j].x, g_p2.t[0][j].y);	// 1.0{
					}
					nml.x = g_p2.n[k][g_p2.f[k][i][j]].x;
					nml.y = g_p2.n[k][g_p2.f[k][i][j]].y;
					nml.z = g_p2.n[k][g_p2.f[k][i][j]].z;
					vtx.x = g_p2.v[k][g_p2.f[k][i][j]].x + m * P_SIZE;
					vtx.y = g_p2.v[k][g_p2.f[k][i][j]].y;
					vtx.z = g_p2.v[k][g_p2.f[k][i][j]].z + (MAP_HGT - 1 - n) * P_SIZE;
					glNormal3f(nml.x, nml.y, nml.z);
					glVertex3f(vtx.x, vtx.y, vtx.z);
				}
				glEnd();
			}
		}
	}
	SwapBuffers(g_hDC);
}// Draw_Passage

// ʘH̉
void Visible_Passage()
{
	int			nx,nz;					// ݂n}̈ʒu
	static int	nx_pre = 0,nz_pre = 0;	// O񂢂n}̈ʒu
	static int	flagDir_pre = -1;		// Ỏ]
	int			dx[4] = {-1, 0, 1, 0};	// eis̈ړl
	int			dz[4] = { 0, 1, 0,-1};	// eis̈ړl

	
	nx = (int)(g_pos_x / P_SIZE);
	nz = MAP_HGT - (int)(g_pos_z / P_SIZE) - 1;
	if(g_roll >= 225 && g_roll < 315){
		g_flagDir = 0;
	}
	else if(g_roll >= 135 && g_roll < 225){
		g_flagDir = 1;
	}
	else if(g_roll >= 45 && g_roll < 135){
		g_flagDir = 2;
	}
	else{
		g_flagDir = 3;
	}
	
	if(nx == nx_pre && nz == nz_pre && g_flagDir == flagDir_pre){
		return;
	}
	
	// tȌ
	for(int z=0;z<MAP_HGT;z++){
		for(int x=0;x<MAP_WDH;x++){
			g_map4[z][x] = 0;
		}
	}
	
	// ݒn̑O̒ʘHS܂˂܂ŃtOPɂ
	int nx2,nz2;
	nx2 = nx;
	nz2 = nz;
	while(Visible_Passage_Sub4(nx2, nz2, g_flagDir, 4)){
		nx2 += dx[g_flagDir];
		nz2 += dz[g_flagDir];
	}
	
	nx_pre      = nx;
	nz_pre      = nz;
	flagDir_pre = g_flagDir;
}// Visible_Passage

// flagDir̓˂܂ł̒ʘHtOPɂB
bool Visible_Passage_Sub (int nx, int nz, int flagDir, int range)
{
	static int ct = 0;
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	g_map4[nz][nx] = 1;
	ct ++;
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	return 1;
}// Visible_Passage_Sub

// flagDir̂P܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub1(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub (nx2, nz2, 1, 3)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub (nx2, nz2, 3, 3)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub (nx2, nz2, 0, 3)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub (nx2, nz2, 2, 3)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub1

// flagDir̂Q܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub2(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub1(nx2, nz2, 1, 3)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub1(nx2, nz2, 3, 3)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub1(nx2, nz2, 0, 3)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub1(nx2, nz2, 2, 3)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub2

// flagDir̂R܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub3(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub2(nx2, nz2, 1, 3)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub2(nx2, nz2, 3, 3)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub2(nx2, nz2, 0, 3)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub2(nx2, nz2, 2, 3)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub3

// flagDir̂S܂˂܂ł̒ʘHtOPɂ
bool Visible_Passage_Sub4(int nx, int nz, int flagDir, int range)
{
	int nx2,nz2;
	static int ct = 0;
	
	if(nx < 0 || nx >= MAP_WDH || nz < 0 || nz >= MAP_HGT || flagDir == (g_flagDir+2)%4){
		ct = 0;
		return 0;
	}
	
	g_map4[nz][nx] = 1;
	
	if(flagDir == 0 || flagDir == 2){
		if(!g_wall[g_map1[nz][nx]-1][1]){
			nx2 = nx;
			nz2 = nz + 1;
			while(Visible_Passage_Sub3(nx2, nz2, 1, 4)){
				nz2 ++;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][3]){
			nx2 = nx;
			nz2 = nz - 1;
			while(Visible_Passage_Sub3(nx2, nz2, 3, 4)){
				nz2 --;
			}
		}
	}
	else{
		if(!g_wall[g_map1[nz][nx]-1][0]){
			nx2 = nx - 1;
			nz2 = nz;
			while(Visible_Passage_Sub3(nx2, nz2, 0, 4)){
				nx2 --;
			}
		}
		if(!g_wall[g_map1[nz][nx]-1][2]){
			nx2 = nx + 1;
			nz2 = nz;
			while(Visible_Passage_Sub3(nx2, nz2, 2, 4)){
				nx2 ++;
			}
		}
	}
	
	ct ++;
	
	if(ct >= range || g_wall[g_map1[nz][nx]-1][flagDir]){
		ct = 0;
		return 0;
	}
	
	return 1;
}// Visible_Passage_Sub4

// ړƉ]
void Go()
{
	int		nx,nz;
	float	go_roll;
	nx = (int)(g_pos_x / P_SIZE);
	nz = (int)((MAP_HGT * P_SIZE - g_pos_z) / P_SIZE);
	
	if(g_map2[nz][nx]){
		g_map2[nz][nx] = 0;
	}
	
	if(nx != 0 && g_map2[nz][nx-1] && Map[nz*2+1][nx*2+1-1] != 1){
		go_roll = 270;
	}
	else if(nx != MAP_WDH-1 && g_map2[nz][nx+1] && Map[nz*2+1][nx*2+1+1] != 1){
		go_roll = 90;
	}
	else if(nz != 0 && g_map2[nz-1][nx] && Map[nz*2+1-1][nx*2+1] != 1){
		go_roll = 0;
	}
	else if(nz != MAP_HGT-1 && g_map2[nz+1][nx] && Map[nz*2+1+1][nx*2+1] != 1){
		go_roll = 180;
	}
	else{	// I
		memcpy(g_map2, g_map3, sizeof(g_map3));	// isoH̏
		return;
	}
	
	if(go_roll == 0 && g_roll >= 270){
		g_roll += 3;
		if(g_roll >= 360)
			g_roll -= 360;
		if((nx != 0 && nz != MAP_HGT-1) || (nx != MAP_WDH-1 && nz != 0)){
			g_pos_x += 0.014f * (float)sin(g_roll/180*PI);
			g_pos_z += 0.014f * (float)cos(g_roll/180*PI);
		}
	}
	else if(go_roll == 270 && g_roll < 90){
		g_roll -= 3;
		if(g_roll < 0)
			g_roll += 360;
		if((nx != 0 && nz != MAP_HGT-1) || (nx != MAP_WDH-1 && nz != 0)){
			g_pos_x += 0.014f * (float)sin(g_roll/180*PI);
			g_pos_z += 0.014f * (float)cos(g_roll/180*PI);
		}
	}
	else if(go_roll-g_roll > 0){
		g_roll += 3;
		if(g_roll >= 360)
			g_roll -= 360;
		if((nx != 0 && nz != MAP_HGT-1) || (nx != MAP_WDH-1 && nz != 0)){
			g_pos_x += 0.014f * (float)sin(g_roll/180*PI);
			g_pos_z += 0.014f * (float)cos(g_roll/180*PI);
		}
	}
	else if(go_roll-g_roll < 0){
		g_roll -= 3;
		if(g_roll < 0)
			g_roll += 360;
		if((nx != 0 && nz != MAP_HGT-1) || (nx != MAP_WDH-1 && nz != 0)){
			g_pos_x += 0.014f * (float)sin(g_roll/180*PI);
			g_pos_z += 0.014f * (float)cos(g_roll/180*PI);
		}
	}
	else{
		g_pos_x += 0.03f * (float)sin(g_roll/180*PI);
		g_pos_z += 0.03f * (float)cos(g_roll/180*PI);
	}
}// Go

// n}̍쐬
void Create_Map()
{
	int		k,x,z;
	bool	map2[HGT][WDH],map4[MAP_HGT][MAP_WDH];
	int		map3[MAP_HGT][MAP_WDH];
	
	// H̎
	Labyrinth();
	
	// 2  0 ɂ
	for(z=0;z<HGT;z++){
		for(x=0;x<WDH;x++){
			if(Map[z][x] == 1){
				map2[z][x] = 1;
			}
			else{
				map2[z][x] = 0;
			}
		}
	}
	
	// n}̍쐬
	for(z=1;z<HGT;z+=2){
		for(x=1;x<WDH;x+=2){
			g_map1[x/2][z/2] = 0;
			for(k=0;k<P_NUM;k++){
				if( map2[z][x-1] == g_wall[k][0] && map2[z][x+1] == g_wall[k][2] && 
					map2[z-1][x] == g_wall[k][3] && map2[z+1][x] == g_wall[k][1]){
					map3[z/2][x/2] = k+1;
					break;
				}
			}
		}
	}
	for(z=0;z<MAP_HGT;z++){
		for(x=0;x<MAP_WDH;x++){
			g_map1[z][x] = map3[z][x];
		}
	}
	
	// isoH̍쐬
	for(z=1;z<HGT;z+=2){
		for(x=1;x<WDH;x+=2){
			if(Map[z][x] == 2){
				map4[z/2][x/2] = 1;
			}
			else{
				map4[z/2][x/2] = 0;
			}
		}
	}
	for(z=0;z<MAP_HGT;z++){
		for(x=0;x<MAP_WDH;x++){
			g_map2[z][x] = g_map3[z][x] = map4[z][x];
		}
	}
}// Create_Map

// ʘHbV̓ǂݍ݁ioCi`j
bool Load_EctFile_Bin(void *pMem, int size)
{
	int		ct = 0,p_ct = 0;
	UINT	len_tag,size_data;
	int		i,k,vtx_ct[P_NUM];
	char	tag[TAG_LEN];
	char	tag_list[][TAG_LEN] = {"parts_count","vertex_count","face_count","vertices","normals","faces"};

	if(pMem == NULL){
		return 0;
	}
	
	ct += (sizeof(char)*4+sizeof(int));	// ǂݔ΂
	while(ct < size){
		memcpy(&len_tag, (BYTE*)pMem+ct, sizeof(int));
		ct += sizeof(int);
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		memcpy(tag, (BYTE*)pMem+ct, sizeof(char)*len_tag);
		ct += sizeof(char)*len_tag;
		memcpy(&size_data, (BYTE*)pMem+ct, sizeof(int));
		ct += sizeof(int);
		bool flag = false;
		for(k=0;k<sizeof(tag_list)/sizeof(tag_list[0]);k++){
			if(!strcmp(tag, tag_list[k])){
				flag = true;
switch(k)
{
case 0:
	memcpy(&p_ct, (BYTE*)pMem+ct, sizeof(int));
	ct += sizeof(int);
	if(p_ct != P_NUM){
		return 0;
	}
	break;
case 1:
	memcpy(vtx_ct, (BYTE*)pMem+ct, sizeof(int)*p_ct);
	ct += sizeof(int)*p_ct;
	break;
case 2:
	memcpy(g_p2.face_ct, (BYTE*)pMem+ct, sizeof(int)*p_ct);
	ct += sizeof(int)*p_ct;
	break;
case 3:
	for(i=0;i<p_ct;i++){
		memcpy(g_p2.v[i], (BYTE*)pMem+ct, sizeof(GLVECTOR3)*vtx_ct[i]);
		ct += sizeof(GLVECTOR3)*vtx_ct[i];
	}
	break;
case 4:
	for(i=0;i<p_ct;i++){
		memcpy(g_p2.n[i], (BYTE*)pMem+ct, sizeof(GLVECTOR3)*vtx_ct[i]);
		ct += sizeof(GLVECTOR3)*vtx_ct[i];
	}
	break;
case 5:
	for(i=0;i<p_ct;i++){
		memcpy(g_p2.f[i], (BYTE*)pMem+ct, sizeof(int[4])*g_p2.face_ct[i]);
		ct += sizeof(int[4])*g_p2.face_ct[i];
	}
	break;
}
				break;
			}
		}
		if(!flag){
			ct += size_data;			// ǂݔ΂
		}
	}
	
	if(!p_ct)
		return 0;
	
	return 1;
}// Load_EctFile_Bin

// ʘHbV̓ǂݍ݁ieLXg`j
bool Load_EctFile(void *pMem)
{
	FILE 	*file1;
	char 	ss[256],*p = NULL;
	float 	ww[8];
	int		flag = 0;
	int 	vv[4],p_ct = 0,ct1 = 0,ct2 = 0;
	
	if(pMem == NULL){
		return 0;
	}
	// e| t@Cɏ
	if((file1 = tmpfile()) == NULL){
		return 0;
	}
	fputs((char*)pMem,file1);
	// t@C|C^擪ɖ߂
	rewind(file1);
	// e| t@Cǂݍ
	while(!feof(file1)){
		
		fgets(ss,256,file1);
		p = strstr(ss,"\r\n");
		if(p){
			strcpy(p,"");
		}
		
		// p[cƂ̒_WƖ@xNg
		if(!strcmp(ss,"<vertices>")){
			flag = 1;
			ct1 = 0;
		}
		else if(!strcmp(ss,"</vertices>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%f %f %f %f %f %f %f %f",&ww[0],&ww[1],&ww[2],&ww[3],&ww[4],&ww[5],&ww[6],&ww[7]);
			g_p2.v[p_ct][ct1].x = ww[0];
			g_p2.v[p_ct][ct1].y = ww[1];
			g_p2.v[p_ct][ct1].z = ww[2];
			g_p2.n[p_ct][ct1].x = ww[3];
			g_p2.n[p_ct][ct1].y = ww[4];
			g_p2.n[p_ct][ct1].z = ww[5];
			ct1 ++;
		}
		
		// p[cƂ̖ʂ\钸_W̔ԍ
		else if(!strcmp(ss,"<faces>")){
			flag = 2;
			ct2 = 0;
		}
		else if(!strcmp(ss,"</faces>")){
			flag = 0;
			g_p2.face_ct[p_ct] = ct2;
		}
		else if(flag == 2){
			sscanf(ss,"%d %d %d %d",&vv[0],&vv[1],&vv[2],&vv[3]);
			g_p2.f[p_ct][ct2][0] = vv[0];
			g_p2.f[p_ct][ct2][1] = vv[1];
			g_p2.f[p_ct][ct2][2] = vv[2];
			g_p2.f[p_ct][ct2][3] = vv[3];
			ct2 ++;
		}
		
		// ǂݍ񂾃p[c̐
		else if(!strcmp(ss,"</polygon_mesh>")){
			p_ct ++;
		}
	}
	
	fclose(file1);
	
	_rmtmp();
	
	return 1;
}// Load_EctFile

// rbg}bv\[X̓ǂݍ
bool LoadBMP()
{
	BITMAPINFO			*pbmi = NULL;
	BYTE				*pbits = NULL;
	int					i,j,width,height,ct = 0;
	int					nColors = 0;	// pbg̐F
	
	ZeroMemory(&g_pTex, sizeof(TEX));

// 蓖
	pbmi = (BITMAPINFO*) LocalAlloc (LPTR, sizeof(BITMAPINFOHEADER)+sizeof(RGBQUAD)*256);
// rbg}bv \[X[h
	HRSRC   hFound = FindResource(NULL, MAKEINTRESOURCE(IDB_BITMAP1), RT_BITMAP);
	HGLOBAL hRes   = LoadResource(NULL, hFound);
	LPBYTE	pMem   = (LPBYTE)LockResource(hRes);
	if(pMem == NULL){
		LocalFree(pbmi);
		return false;
	}
	memcpy(&pbmi->bmiHeader, pMem, sizeof(pbmi->bmiHeader));
	ct += sizeof(pbmi->bmiHeader);
	if(pbmi->bmiHeader.biBitCount != 8 && pbmi->bmiHeader.biBitCount != 24) {	// 1, 4, 16, 32 bit F̏ꍇ
		LocalFree(pbmi);
		return false;
	}
// J[e[uΓǂ
	if (pbmi->bmiHeader.biBitCount <= 8) {
		if(pbmi->bmiHeader.biClrUsed != 0 )
			nColors = pbmi->bmiHeader.biClrUsed;
		else
			nColors = 1 << pbmi->bmiHeader.biBitCount;
		memcpy(pbmi->bmiColors, pMem + ct, nColors * sizeof(RGBQUAD));
		ct += (nColors * sizeof(RGBQUAD));
	}
// f[^ǂ
	int wdhbyts = WIDTHBYTES(pbmi);
	int size = wdhbyts * pbmi->bmiHeader.biHeight;
	pbits = (BYTE *) LocalAlloc (LPTR, size);
	memcpy(pbits, pMem + ct, size);
// Oϐɓ
	g_pTex.wdh = pbmi->bmiHeader.biWidth;
	g_pTex.hgt = pbmi->bmiHeader.biHeight;
	g_pTex.data = new BYTE [g_pTex.wdh * g_pTex.hgt * 3];
	width  = g_pTex.wdh * 3;
	height = g_pTex.hgt;
	if(pbmi->bmiHeader.biBitCount == 8){ 		// 8bitF̂Ƃ
		for(j=0; j<height; j++){
			for(i=0; i<width; i+=3){
				int pal_idx = pbits[j * wdhbyts + i/3];
				g_pTex.data[j * width + i + 0] = pbmi->bmiColors[pal_idx].rgbRed;	// ԐF
				g_pTex.data[j * width + i + 1] = pbmi->bmiColors[pal_idx].rgbGreen;	// ΐF
				g_pTex.data[j * width + i + 2] = pbmi->bmiColors[pal_idx].rgbBlue;	// F
			}
		}
	}
	else if(pbmi->bmiHeader.biBitCount == 24){	 // 24bitF̂Ƃ
		for(j=0; j<height; j++){
			for(i=0; i<width; i+=3){
				g_pTex.data[j * width + i + 0] = pbits[j * wdhbyts + i + 2];	// ԐF
				g_pTex.data[j * width + i + 1] = pbits[j * wdhbyts + i + 1];	// ΐF
				g_pTex.data[j * width + i + 2] = pbits[j * wdhbyts + i + 0];	// F
			}
		}
	}
	memcpy(pbits, pMem + ct, size);
// 
	LocalFree(pbmi);
	pbmi = NULL;
	LocalFree(pbits);
	pbits = NULL;
	return true;
}// LoadBMP

// I
void Term(HWND hWnd)
{
	SAFE_DELETE(g_pTex.data);
	
	if(g_hRC){
		wglDeleteContext(g_hRC);
		g_hRC = NULL;
	}
	if(g_hDC){
		ReleaseDC(hWnd, g_hDC);
		g_hDC = NULL;
	}
}// Term
